Package javassist.runtime

# Class Desc

java.lang.Object
javassist.runtime.Desc

public class Desc extends Object
A support class for implementing `$sig` and `$type`. This support class is required at runtime only if `$sig` or `$type` is used.

## Field Summary

Fields
Modifier and Type
Field
Description
`static boolean`
`useContextClassLoader`
Specifies how a `java.lang.Class` object is loaded.

## Constructor Summary

Constructors
Constructor
Description
`Desc()`

## Method Summary

Modifier and Type
Method
Description
`static Class<?>`
`getClazz(String name)`
Interprets the given class name.
`static Class<?>[]`
`getParams(String desc)`
Interprets the given type descriptor representing a method signature.
`static Class<?>`
`getType(String desc)`
Interprets the given type descriptor.
`static void`
`resetUseContextClassLoaderLocally()`
Changes so that the current thread will not use the context class loader when a class is loaded.
`static void`
`setUseContextClassLoaderLocally()`
Changes so that the current thread will use the context class loader when a class is loaded.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### useContextClassLoader

public static boolean useContextClassLoader
Specifies how a `java.lang.Class` object is loaded.

If true, it is loaded by:

    Thread.currentThread().getContextClassLoader().loadClass()

If false, it is loaded by `Class.forName()`. The default value is false.

## Constructor Details

### Desc

public Desc()

## Method Details

### setUseContextClassLoaderLocally

public static void setUseContextClassLoaderLocally()
Changes so that the current thread will use the context class loader when a class is loaded. This method changes the behavior per thread unlike `useContextClassLoader`.

Since:
  3.25

### resetUseContextClassLoaderLocally

public static void resetUseContextClassLoaderLocally()
Changes so that the current thread will not use the context class loader when a class is loaded. Call this method before releasing the current thread for reuse. It invokes `ThreadLocal.remvoe()`.

Since:
  3.25

### getClazz

public static Class<?> getClazz(String name)
Interprets the given class name. It is used for implementing `$class`.

### getParams

public static Class<?>[] getParams(String desc)
Interprets the given type descriptor representing a method signature. It is used for implementing `$sig`.

### getType

public static Class<?> getType(String desc)
Interprets the given type descriptor. It is used for implementing `$type`.